<?php

/**
 * @author {@link mailto:corey@onpubco.com Corey HM Taylor}
 * @copyright Onpub (TM) Copyright (C) 2008, Onpubco
 * {@link http://onpubco.com/}
 * @license http://www.gnu.org/copyleft/gpl.html GNU General Public License
 * Version 2
 * @package onpubgui
 * @version 0.8.7
 */
class OnpubLogin
{
    private $pdoDatabase;
    private $pdoUser;
    private $pdoPassword;
    private $logout;
    private $target;
    private $rememberLogin;
    private $exception;

    function __construct( $pdoDatabase = "", $pdoUser = "", $pdoPassword = "", $logout = false, $target = null, $rememberLogin = false, $exception = null )
    {
        $this->pdoDatabase = $pdoDatabase;
        $this->pdoUser = $pdoUser;
        $this->pdoPassword = $pdoPassword;
        $this->logout = $logout;
        $this->target = $target;
        $this->rememberLogin = $rememberLogin;
        $this->exception = $exception;
    }

    public function display()
    {
        echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">' . "\n";
        echo '<html>' . "\n";
        echo '<head>' . "\n";
        echo '<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />' . "\n";
        echo '<link rel="stylesheet" type="text/css" href="gui/css/onpub.css" />' . "\n";
        echo '<script src="gui/js/onpub.js" type="text/javascript"></script>' . "\n";
        echo '<title>Onpub (on ' . $_SERVER['SERVER_NAME'] . ')</title>' . "\n";
        echo '</head>' . "\n";
        echo '<body>' . "\n";

        echo '<form action="index.php" method="post">' . "\n";

        echo '<table align="center" border="0">' . "\n";
        echo '<tr>' . "\n";
        echo '<td align="center"><a href="index.php"><img src="gui/images/onpub.png" width="130" height="40" alt="Onpub" title="Onpub" border="0" /></a></td>' . "\n";
        echo '</tr>' . "\n";
        echo '<tr>' . "\n";

        if ( $this->pdoDatabase === null ) {
            echo '<td><b>Database</b><br /><input type="text" maxlength="255" size="' . 30 . '" name="pdoDatabase" value="" /> <img src="gui/icons/exclamation.png" align="top" alt="Required field" title="Required field" /></td>' . "\n";
        }
        else {
            echo '<td><b>Database</b><br /><input type="text" maxlength="255" size="' . 30 . '" name="pdoDatabase" value="' . htmlentities( $this->pdoDatabase ) . '" /></td>' . "\n";
        }

        echo '</tr>' . "\n";

        echo '<tr>' . "\n";
        echo '<td><b>Username</b><br /><input type="text" maxlength="255" size="' . 30 . '" name="pdoUser" value="' . htmlentities( $this->pdoUser ) . '" /></td>' . "\n";
        echo '</tr>' . "\n";

        echo '<tr>' . "\n";
        echo '<td><b>Password</b><br /><input type="password" maxlength="255" size="' . 30 . '" name="pdoPassword" value="" /></td>' . "\n";
        echo '</tr>' . "\n";

        echo '<tr>' . "\n";
        echo '<td><a href="javascript:submitForm();"><img src="' . ONPUBGUI_IMAGE_DIRECTORY . 'login.png" border="0" alt="Login" title="Login" /></a></td>' . "\n";
        echo '</tr>' . "\n";

/*
        echo '<tr>' . "\n";

        if ( $this->rememberLogin ) {
            echo '<td><input type="checkbox" id="id_rememberLogin" name="rememberLogin" value="1" checked="checked" /> <label for="id_rememberLogin">Remember me on this computer</label></td>' . "\n";
        }
        else {
            echo '<td><input type="checkbox" id="id_rememberLogin" name="rememberLogin" value="1" /> <label for="id_rememberLogin">Remember me on this computer</label></td>' . "\n";
        }

        echo '</tr>' . "\n";
*/

        echo '</table>' . "\n";

        if ( $this->exception ) {
            echo '<br /><div align="center"><span class="error">' . $this->exception->getMessage() . '</span></div>' . "\n";
        }

        echo '<div><input type="hidden" name="onpub" value="LoginProcess" /></div>' . "\n";

        if ( $this->target ) {
            $newTarget = "";

            if ( is_array( $this->target ) ) {
                $keys = array_keys( $this->target );

                for ( $i = 0; $i < sizeof( $keys ); $i++ ) {
                    $newTarget .= $keys[$i] . "=" . $this->target[$keys[$i]];

                    if ( ($i + 1) != sizeof( $keys ) ) {
                        $newTarget .= "&";
                    }
                }

                $this->target = $newTarget;
            }

            echo '<div><input type="hidden" name="target" value="' . $this->target . '" /></div>' . "\n";
        }

        echo '</form>' . "\n";
    }

    public function validate()
    {
        if ( !$this->pdoDatabase ) {
            $this->pdoDatabase = null;
            return false;
        }

        try {
            $pdo = new PDO( "mysql:host=localhost;dbname=$this->pdoDatabase", $this->pdoUser, $this->pdoPassword );
        }
        catch ( PDOException $e ) {
            throw $e;
        }

        $pdo = null;
        return true;
    }

    public function process()
    {
        if ( $this->logout ) {
            $_SESSION = array();

            if ( isset( $_COOKIE[session_name()] ) ) {
               setcookie( session_name(), "", (time() - 42000), "/" );
            }

            session_destroy();
            return 0;
        }

        session_regenerate_id();

        $_SESSION['PDO_HOST'] = "localhost";
        $_SESSION['PDO_USER'] = $this->pdoUser;
        $_SESSION['PDO_PASSWORD'] = $this->pdoPassword;
        $_SESSION['PDO_DATABASE'] = $this->pdoDatabase;
    }

    public function getTarget()
    {
        return $this->target;
    }

    public function setException( $exception )
    {
        $this->exception = $exception;
    }
}

?>
