<?php

/**
 * @author {@link mailto:corey@onpubco.com Corey HM Taylor}
 * @copyright Onpub (TM) Copyright (C) 2008, Onpubco
 * {@link http://onpubco.com/}
 * @license http://www.gnu.org/copyleft/gpl.html GNU General Public License
 * Version 2
 * @package onpubgui
 * @version 0.8.7
 */
class OnpubMoveArticles
{
    private $pdo;
    private $IDs;
    private $sectionIDs;

    function __construct( PDO $pdo, $IDs, $sectionIDs = array() )
    {
        $this->pdo = $pdo;
        $this->IDs = $IDs;
        $this->sectionIDs = $sectionIDs;
    }

    public function display()
    {
        $oarticles = new OnpubArticles( $this->pdo );
        $osections = new OnpubSections( $this->pdo );
        $owebsites = new OnpubWebsites( $this->pdo );
        $articles = array();
        $websites = array();

        try {
            if ( is_array( $this->IDs ) ) {
                $queryOptions = new OnpubQueryOptions();
                $queryOptions->includeContent = false;

                for ( $i = 0; $i < sizeof( $this->IDs ); $i++ ) {
                    $articles[] = $oarticles->get( $this->IDs[$i], $queryOptions );
                }
            }

            $queryOptions = new OnpubQueryOptions();
            $queryOptions->orderBy = "name";
            $queryOptions->order = "ASC";
            $websites = $owebsites->select( $queryOptions );
        }
        catch ( PDOException $e ) {
            throw $e;
        }

        $widget = new OnpubWidgetHeader( "Move Articles" );
        $widget->display();

        echo '<form action="index.php" method="post">' . "\n";

        echo '<div class="no-table">' . "\n";

        if ( sizeof( $articles ) ) {
            if ( sizeof( $articles ) > 1 ) {
                echo '<b>Selected Articles</b>' . "\n";
            }
            else {
                echo '<b>Selected Article</b>' . "\n";
            }

            echo '<br />' . "\n";

            for ( $i = 0; $i < sizeof( $articles ); $i++ ) {
                echo '<a href="index.php?onpub=ViewArticle&amp;ID=' . $articles[$i]->ID . '" title="View">' . $articles[$i]->title . '</a><br />' . "\n";
                echo '<div><input type="hidden" name="IDs[]" value="' . $articles[$i]->ID . '" /></div>' . "\n";
            }

            echo '<br />' . "\n";

            $widget = new OnpubWidgetSections( null, $websites, $osections, array(), "Sections", true, "sectionIDs[]", null, null, false, "10" );
            $widget->display();

            echo '<br /><br />' . "\n";

            echo '<a href="javascript:submitForm();"><img src="' . ONPUBGUI_IMAGE_DIRECTORY . 'save.png" width="60" height="25" border="0" alt="Save" title="Save" /></a>' . "\n";
        }
        else {
            echo '<span class="error">No articles were selected to move.</span>' . "\n";
        }

        echo '</div>' . "\n";

        echo '<div><input type="hidden" name="onpub" value="ArticleMoveProcess" /></div>' . "\n";

        echo '</form>' . "\n";

        $widget = new OnpubWidgetFooter();
        $widget->display();
    }

    public function validate()
    {

    }

    public function process()
    {
        $oarticles = new OnpubArticles( $this->pdo );
        $queryOptions = new OnpubQueryOptions();
        $queryOptions->includeAuthors = true;

        try {
            for ( $i = 0; $i < sizeof( $this->IDs ); $i++ ) {
                $article = $oarticles->get( $this->IDs[$i], $queryOptions );
                $article->sectionIDs = $this->sectionIDs;
                $oarticles->update( $article );
            }
        }
        catch ( PDOException $e ) {
            throw $e;
        }
    }
}

?>
