<?php

/**
 * @author {@link mailto:corey@onpubco.com Corey HM Taylor}
 * @copyright Onpub (TM) Copyright (C) 2008, Onpubco
 * {@link http://onpubco.com/}
 * @license http://www.gnu.org/copyleft/gpl.html GNU General Public License
 * Version 2
 * @package onpubgui
 * @version 0.8.7
 */
class OnpubUploadImages
{
    private $pdo;
    private $imageID;
    private $imageFile;
    private $fileName;
    private $websiteID;

    function __construct( PDO $pdo, $imageFile = "", $fileName = "", $websiteID = null )
    {
        $this->pdo = $pdo;
        $this->imageID = null;
        $this->imageFile = $imageFile;
        $this->fileName = $fileName;
        $this->websiteID = $websiteID;
    }

    public function display()
    {
        $owebsites = new OnpubWebsites( $this->pdo );

        try {
            $queryOptions = new OnpubQueryOptions();
            $queryOptions->orderBy = "name";
            $queryOptions->order = "ASC";
            $websites = $owebsites->select( $queryOptions );
        }
        catch ( PDOException $e ) {
            throw $e;
        }

        $widget = new OnpubWidgetHeader( "Upload Images" );
        $widget->display();

        echo '<form action="index.php" method="post" enctype="multipart/form-data">' . "\n";

        echo '<table border="0" cellpadding="5" cellspacing="0">' . "\n";
        echo '<tr>' . "\n";

        echo '<td>' . "\n";

        if ( $this->fileName === null ) {
            echo '<b>Image File</b><br /><input type="file" size="70" name="imageFile[]" /> <img src="gui/icons/exclamation.png" align="top" alt="Required field" title="Required field" /><br /><br />' . "\n";
        }
        else {
            echo '<b>Image File</b><br /><input type="file" size="70" name="imageFile[]" /><br /><br />' . "\n";
        }

        echo '<b>Image File</b><br /><input type="file" size="70" name="imageFile[]" /><br /><br />' . "\n";
        echo '<b>Image File</b><br /><input type="file" size="70" name="imageFile[]" /><br /><br />' . "\n";
        echo '<b>Image File</b><br /><input type="file" size="70" name="imageFile[]" /><br /><br />' . "\n";
/*
        echo '<b>Image File</b><br /><input type="file" size="70" name="imageFile[]" /><br /><br />' . "\n";
        echo '<b>Image File</b><br /><input type="file" size="70" name="imageFile[]" /><br /><br />' . "\n";
        echo '<b>Image File</b><br /><input type="file" size="70" name="imageFile[]" /><br /><br />' . "\n";
        echo '<b>Image File</b><br /><input type="file" size="70" name="imageFile[]" /><br /><br />' . "\n";
        echo '<b>Image File</b><br /><input type="file" size="70" name="imageFile[]" /><br /><br />' . "\n";
        echo '<b>Image File</b><br /><input type="file" size="70" name="imageFile[]" /><br /><br />' . "\n";
        echo '<b>Image File</b><br /><input type="file" size="70" name="imageFile[]" /><br /><br />' . "\n";
        echo '<b>Image File</b><br /><input type="file" size="70" name="imageFile[]" /><br /><br />' . "\n";
        echo '<b>Image File</b><br /><input type="file" size="70" name="imageFile[]" /><br /><br />' . "\n";
        echo '<b>Image File</b><br /><input type="file" size="70" name="imageFile[]" /><br /><br />' . "\n";
        echo '<b>Image File</b><br /><input type="file" size="70" name="imageFile[]" /><br /><br />' . "\n";
        echo '<b>Image File</b><br /><input type="file" size="70" name="imageFile[]" /><br /><br />' . "\n";
        echo '<b>Image File</b><br /><input type="file" size="70" name="imageFile[]" /><br /><br />' . "\n";
        echo '<b>Image File</b><br /><input type="file" size="70" name="imageFile[]" /><br /><br />' . "\n";
        echo '<b>Image File</b><br /><input type="file" size="70" name="imageFile[]" /><br /><br />' . "\n";
*/
        echo '<b>Image File</b><br /><input type="file" size="70" name="imageFile[]" />' . "\n";

        echo '</td>' . "\n";

        $widget = new OnpubWidgetWebsites( $this->websiteID, $websites, "image" );
        $widget->display();

        echo '<tr>' . "\n";
        echo '<td><a href="javascript:submitForm();"><img src="' . ONPUBGUI_IMAGE_DIRECTORY . 'upload.png" border="0" alt="" /></a></td>';
        echo '</tr>' . "\n";
        echo '</table>' . "\n";

        echo '<div><input type="hidden" name="onpub" value="UploadImagesProcess" /></div>' . "\n";

        echo '</form>' . "\n";

        $widget = new OnpubWidgetFooter();
        $widget->display();
    }

    public function displayException( Exception $e )
    {
        $owebsites = new OnpubWebsites( $this->pdo );

        try {
            $website = $owebsites->get( $this->websiteID );
        }
        catch ( PDOException $e ) {
            throw $e;
        }

        $widget = new OnpubWidgetHeader( "Upload Images" );
        $widget->display();

        echo '<form action="index.php" method="post" enctype="multipart/form-data">' . "\n";

        echo '<table border="0" cellpadding="5" cellspacing="0">' . "\n";
        echo '<tr>' . "\n";
        echo '<td>' . "\n";

        switch ( $e->getCode() ) {
            case ONPUBGUI_ERROR_MOVE_UPLOADED_FILE:
            echo '<span class="error">' . $e->getMessage() . '</span>' . "\n";
            echo '<br />' . "\n";
            echo '<span class="tip">Tip:</span> make sure the Images Directory of Website <a href="index.php?onpub=EditWebsite&amp;websiteID=' . $this->websiteID . '">' . $website->name . '</a> is setup correctly.' . "\n";
            break;
            default:
            echo '<span class="error">' . $e->getMessage() . '</span>' . "\n";
            break;
        }

        echo '</td>' . "\n";
        echo '</tr>' . "\n";
        echo '</table>' . "\n";

        $widget = new OnpubWidgetFooter();
        $widget->display();
    }

    public function validate()
    {
        $valid = false;

        if ( is_array( $this->fileName ) ) {
            foreach ( $this->fileName as $fileName ) {
                if ( $fileName ) {
                    $valid = true;
                    break;
                }
            }
        }
        else {
            $valid = true;
        }

        if ( !$valid ) {
            $this->fileName = null;
        }

        if ( !$this->websiteID ) {
            $this->websiteID = "";
            $valid = false;
        }

        return $valid;
    }

    public function process()
    {
        if ( !ini_get( "file_uploads" ) ) {
            $message = "File uploads are disabled in the current PHP configuration.";
            throw new Exception( $message, ONPUBGUI_ERROR_IMAGE_TYPE );
        }

        $oimages = new OnpubImages( $this->pdo );
        $owebsites = new OnpubWebsites( $this->pdo );

        for ( $i = 0; $i < sizeof( $this->fileName ); $i++ ) {
            if ( $this->fileName[$i] ) {
                if ( !($ext = $this->isValidImage( $this->fileName[$i] )) ) {
                    $message = "<i>" . $this->fileName[$i] . "</i> is an unsupported image file type.";
                    throw new Exception( $message, ONPUBGUI_ERROR_IMAGE_TYPE );
                }

                $image = new OnpubImage();
                $image->websiteID = $this->websiteID;
                $image->fileName = $this->fileName[$i];

                try {
                    $this->imageID = $oimages->getID( $image );
                }
                catch ( PDOException $e ) {
                    throw $e;
                }

                if ( !$this->imageID ) {
                    try {
                        $website = $owebsites->get( $image->websiteID );
                    }
                    catch ( PDOException $e ) {
                        throw $e;
                    }

                    if ( is_uploaded_file( $this->imageFile[$i] ) ) {
                        if ( !@move_uploaded_file( $this->imageFile[$i], $website->imagesDirectory . $this->fileName[$i] ) ) {
                            $imagesDirectory = $website->imagesDirectory;
                            $message = "Unable to move <i>" . $this->imageFile[$i] . "</i> to <i>$imagesDirectory" . $this->fileName[$i] . "</i>.";
                            throw new Exception( $message, ONPUBGUI_ERROR_MOVE_UPLOADED_FILE );
                        }
/*
                        if ( !chmod( $website->imagesDirectory . $this->fileName[$i], 0664 ) ) {
                            $imagesDirectory = $website->imagesDirectory;
                            $message = "Unable to change the file permissions of <i>$imagesDirectory" . $this->fileName[$i] . "</i>.";
                            throw new Exception( $message, ONPUBGUI_ERROR_CHMOD );
                        }
*/
                        try {
                            $this->imageID = $oimages->insert( $image );
                        }
                        catch ( PDOException $e ) {
                            throw $e;
                        }
                    }
                    else {
                        $imagesDirectory = $website->imagesDirectory;
                        $message = "<i>" . $this->fileName[$i] . "</i> file size is larger than the current PHP configuration allows.";
                        throw new Exception( $message, ONPUBGUI_ERROR_CHMOD );
                    }
                }
            }
        }
    }

    public function getImageID()
    {
        return $this->imageID;
    }

    public function isValidImage( $fileName )
    {
        $ext = null;
        $validTypes = array( 'gif', 'jpg', 'jpeg', 'png', 'swf', 'psd', 'bmp', 'tiff',
                     'jpc', 'jp2', 'jpf', 'jb2', 'swc', 'aiff', 'wbmp', 'xbm',
                     'ico' );

        $pathinfo = pathinfo( $fileName );

        if ( isset( $pathinfo['extension'] ) ) {
            $ext = strtolower( $pathinfo['extension'] );
        }

        if ( in_array( $ext, $validTypes ) ) {
            return $ext;
        }

        return false;
    }
}

?>
