<?php

/**
 * @author {@link mailto:corey@onpubco.com Corey HM Taylor}
 * @copyright Onpub (TM) Copyright (C) 2008, Onpubco
 * {@link http://onpubco.com/}
 * @license http://www.gnu.org/copyleft/gpl.html GNU General Public License
 * Version 2
 * @package onpubgui
 * @version 0.8.7
 */
class OnpubViewArticle
{
    private $pdo;
    private $ID;

    function __construct( PDO $pdo, $ID )
    {
        $this->pdo = $pdo;
        $this->ID = $ID;
    }

    public function display()
    {
        $oarticles = new OnpubArticles( $this->pdo );
        $osections = new OnpubSections( $this->pdo );
        $oimages = new OnpubImages( $this->pdo );
        $owebsites = new OnpubWebsites( $this->pdo );
        $osamaps = new OnpubSAMaps( $this->pdo );

        $queryOptions = new OnpubQueryOptions();
        $queryOptions->includeAuthors = true;
        $article = $oarticles->get( $this->ID, $queryOptions );
        $created = $article->getCreated();
        $modified = $article->getModified();
        $authors = $article->authors;
        $websites = $owebsites->select( new OnpubQueryOptions() );
        $websitesassoc = array();
        $queryOptions = new OnpubQueryOptions();
        $samaps = $osamaps->select( $queryOptions, null, $this->ID );
        $sections = array();

        foreach ( $samaps as $samap ) {
            $sections[] = $osections->get( $samap->sectionID );
        }

        foreach ( $websites as $website ) {
            $ID = $website->ID;
            $websitesassoc["$ID"] = $website;
        }

        if ( $article->imageID ) {
            $image = $article->image;
        }

        $widget = new OnpubWidgetHeader( "Article - " . $article->title );
        $widget->display();

        echo '<table width="100%" border="0" cellpadding="5" cellspacing="0">' . "\n";
        echo '<tr>' . "\n";
        echo '<td class="buttons"><a href="index.php?onpub=EditArticle&amp;ID=' . $article->ID . '"><img src="' . ONPUBGUI_IMAGE_DIRECTORY . 'edit.png" width="60" height="25" alt="Edit" title="Edit" border="0" /></a></td>' . "\n";
        echo '</tr>' . "\n";

        echo '<tr>' . "\n";
        echo '<td><b>ID</b><br />' . $article->ID . '</td>' . "\n";
        echo '</tr>' . "\n";

        echo '<tr>' . "\n";
        echo '<td><b>Created</b><br />' . $created->format( 'M j, Y g:i:s A' ) . '</td>' . "\n";
        echo '</tr>' . "\n";

        echo '<tr>' . "\n";
        echo '<td><b>Modified</b><br />' . $modified->format( 'M j, Y g:i:s A' ) . '</td>' . "\n";
        echo '</tr>' . "\n";

        if ( sizeof ( $sections ) ) {
            echo '<tr valign="top">' . "\n";
            echo '<td>' . "\n";

            echo '<b>' . "\n";

            if ( sizeof( $sections ) == 1 ) {
                echo 'Section ';
            }
            elseif ( sizeof( $sections ) > 1 ) {
                echo 'Sections ';
            }
            else {
                // no sections
            }

            echo '</b><br />' . "\n";

            for ( $i = 0; $i < sizeof( $sections ); $i++ ) {
                $sectionWebsiteID = $sections[$i]->websiteID;

                if ( $i + 1 == sizeof( $sections ) ) {
                    echo '<a href="index.php?onpub=EditSection&amp;ID=' . $sections[$i]->ID . '" title="Edit">' . $sections[$i]->name . '</a> Website: <a href="index.php?onpub=EditWebsite&amp;ID=' . $sections[$i]->websiteID . '" title="Edit">' . $websitesassoc["$sectionWebsiteID"]->name . '</a>';
                }
                else {
                    echo '<a href="index.php?onpub=EditSection&amp;ID=' . $sections[$i]->ID . '" title="Edit">' . $sections[$i]->name . '</a> Website: <a href="index.php?onpub=EditWebsite&amp;ID=' . $sections[$i]->websiteID . '" title="Edit">' . $websitesassoc["$sectionWebsiteID"]->name . '</a><br />';
                }
            }

            echo '</td>' . "\n";
            echo '</tr>' . "\n";
        }

        if ( $article->url ) {
            echo '<tr>' . "\n";
            echo '<td><b>URL</b><br /><a href="' . $article->url . '" target="_blank" title="Go">' . $article->url . '</a></td>' . "\n";
            echo '</tr>' . "\n";
        }

        echo '<tr>' . "\n";
        echo '<td><b>Title</b><br /><a href="index.php?onpub=EditArticle&amp;ID=' . $article->ID . '" title="Edit">' . $article->title . '</a></td>' . "\n";
        echo '</tr>' . "\n";

        if ( sizeof( $authors ) ) {
            echo '<tr valign="top">' . "\n";
            echo '<td>' . "\n";

            echo '<b>' . "\n";

            if ( sizeof( $authors ) == 1 ) {
                echo 'Author ';
            }
            elseif ( sizeof( $authors ) > 1 ) {
                echo 'Aritcle Authors ';
            }
            else {
                // no authors
            }

            echo '</b><br />' . "\n";

            for ( $i = 0; $i < sizeof( $authors ); $i++ ) {
                if ( $i + 1 == sizeof( $authors ) ) {
                    echo $authors[$i]->displayAs;
                }
                else {
                    echo $authors[$i]->displayAs . '<br />';
                }
            }

            echo '</td>' . "\n";
            echo '</tr>' . "\n";
        }

        echo '</table>' . "\n";

        echo '<div class="no-table">' . "\n";

        echo '<hr />' . "\n";

        echo $article->content . "\n";

        echo '<br />' . "\n";

        echo '<hr />' . "\n";

        if ( $article->imageID ) {
            echo '<b>Image</b><br />' . "\n";

            $image = $article->image;
            $imageWebsiteID = $image->websiteID;
            $website = $websitesassoc["$imageWebsiteID"];

            if ( file_exists( $website->imagesDirectory . $image->fileName ) ) {
                $imageDimensions = getimagesize( $website->imagesDirectory . $image->fileName );
                $imageFileInfo = stat( $website->imagesDirectory . $image->fileName );

                $imageFileSize = $imageFileInfo[7];
                $imageWidth = $imageDimensions[0];
                $imageHeight = $imageDimensions[1];
            }
            else {
                $imageWidth = "";
                $imageHeight = "";
            }

            if ( @fopen( $website->imagesURL . $image->fileName, 'r' ) ) {
                echo '<a href="index.php?onpub=EditImage&amp;ID=' . $image->ID . '"><img src="' . $website->imagesURL . $image->fileName . '" width="' . $imageWidth . '" height="' . $imageHeight . '" alt="Edit" title="Edit" border="0" /></a>' . "\n";
            }
            else {
                echo '<span class="error">Can\'t display ' . $image->fileName . ', make sure <a href="index.php?onpub=EditWebsite&amp;ID=' . $website->ID . '" title="Edit">' . $website->name . '</a>\'s <b>Images URL</b> is setup correctly.</span>' . "\n";
            }
        }

        echo '</div>' . "\n";


        $widget = new OnpubWidgetFooter();
        $widget->display();
    }
}

?>
