<?php

/**
 * @author {@link mailto:corey@onpubco.com Corey HM Taylor}
 * @copyright Onpub (TM) Copyright (C) 2008, Onpubco
 * {@link http://onpubco.com/}
 * @license http://www.gnu.org/copyleft/gpl.html GNU General Public License
 * Version 2
 * @package onpubgui
 * @version 0.8.7
 */
class OnpubWelcome
{
    private $pdo;

    function __construct( PDO $pdo )
    {
        $this->pdo = $pdo;
    }

    public function display()
    {
        $odatabase = new OnpubDatabase( $this->pdo );
        $oarticles = new OnpubArticles( $this->pdo );
        $oauthors = new OnpubAuthors( $this->pdo );
        //$ocomments = new OnpubComments( $this->pdo );
        $oimages = new OnpubImages( $this->pdo );
        $osections = new OnpubSections( $this->pdo );
        $owebsites = new OnpubWebsites( $this->pdo );
        $status = $odatabase->status();
        $driver = $this->pdo->getAttribute( PDO::ATTR_DRIVER_NAME );

        $widget = new OnpubWidgetHeader( "Welcome" );
        $widget->display();

        echo '<div class="no-table">' . "\n";

        echo 'Onpub ' . ONPUBAPI_VERSION . ', Copyright &copy; 2007 <a href="http://onpubco.com/" target="_blank">Onpubco</a>.' . "\n";
        echo '<br /><br />' . "\n";
        echo '<b>Database Connection</b><br />' . "\n";
        echo 'Connected database: <i>' . $_SESSION['PDO_DATABASE'] . '</i><br />' . "\n";

        if ( $driver != "sqlite" ) {
            echo 'Connected user: <i>' . $_SESSION['PDO_USER'] . '</i><br />' . "\n";
        }

        echo 'Database client: <i>' . $this->pdo->getAttribute( PDO::ATTR_CLIENT_VERSION ) . '</i> (on <i>' . $_SERVER['SERVER_NAME'] . '</i>)<br />' . "\n";
        echo 'Database driver: <i>' . $driver . '</i><br />' . "\n";

        if ( $driver != "sqlite" ) {
            echo 'Database host: <i>' . $this->pdo->getAttribute( PDO::ATTR_CONNECTION_STATUS ) . '</i><br />' . "\n";
        }

        if ( $driver != "sqlite" ) {
            echo 'Database server: <i>' . $this->pdo->getAttribute( PDO::ATTR_SERVER_VERSION ) . '</i><br />' . "\n";
        }

        echo '<br />' . "\n";

        if ( is_array( $status ) ) {
            $result = '<span class="error">';

            foreach( $status as $e ) {
                $result .= '<br />' . $e->getMessage();
            }

            $result .= '</span><br /><a href="index.php?onpub=SchemaInstall">Install missing tables</a> (required)';
        }
        else {
            if ( $_SERVER['SERVER_NAME'] == 'codebeast.onpubco.com' || $_SERVER['SERVER_NAME'] == 'codebeast' ) {
                $result = '<br />All tables are installed.<!--<br /><a href="index.php?onpub=DataBackup">Backup the database</a><br /><a href="index.php?onpub=DataRestore">Restore a previous backup</a>--><br /><a href="index.php?onpub=DataDelete">Delete all tables</a>';
            }
            else {
                $result = '<br />All tables are installed.<!--<br /><a href="index.php?onpub=DataBackup">Backup the database</a><br /><a href="index.php?onpub=DataRestore">Restore a previous backup</a>-->';
            }
        }

        echo '<b>Database Tables</b>' . "\n";
        echo $result . '<br />' . "\n";
        echo '<br />' . "\n";

        if ( $status === true ) {
            echo '<b>Content Stats</b><br />' . "\n";
            echo 'Articles: ' . $oarticles->count() . '<br />' . "\n";
            echo 'Authors: ' . $oauthors->count() . '<br />' . "\n";
            //echo 'Comments: ' . $ocomments->count() . '<br />' . "\n";
            echo 'Images: ' . $oimages->count() . '<br />' . "\n";
            echo 'Sections: ' . $osections->count() . '<br />' . "\n";
            echo 'Websites: ' . $owebsites->count() . '<br />' . "\n";
            echo '<br />' . "\n";
        }

        echo '<b>PHP Configuration</b><br />' . "\n";
        //echo 'Supported Image Types: ' .  . '<br />' . "\n";

        if ( ini_get( "file_uploads" ) ) {
            echo '<a href="http://php.net/ini.core#ini.file-uploads" target="_blank">Allow File Uploads</a>: <i>Yes</i><br />' . "\n";
        }
        else {
            echo '<a href="http://php.net/ini.core#ini.file-uploads" target="_blank">Allow File Uploads</a>: <i>No</i><br />' . "\n";
        }

        if ( ini_get( "upload_max_filesize" ) ) {
            echo '<a href="http://php.net/ini.core#ini.upload-max-filesize" target="_blank">Upload Maximum File Size</a>: <i>' . ini_get( "upload_max_filesize" ) . '</i><br />' . "\n";
        }
        else {
            echo '<a href="http://php.net/ini.core#ini.upload-max-filesize" target="_blank">Upload Maximum File Size</a>: <i>undefined</i><br />' . "\n";
        }

        if ( ini_get( "date.timezone" ) ) {
            echo '<a href="http://php.net/ref.datetime" target="_blank">Timezone</a>: <i>' . ini_get( "date.timezone" ) . '</i><br />' . "\n";
        }
        else {
            echo '<a href="http://php.net/ref.datetime" target="_blank">Timezone</a>: <i>undefined</i> (using <i>' . ONPUBGUI_DEFAULT_TZ . '</i> by default)<br />' . "\n";
        }

        echo '<br />' . "\n";
        echo '<b>PHP Extensions</b><br />' . "\n";

        if ( function_exists( "tidy_repair_string" ) ) {
            echo '<a href="http://php.net/ref.tidy" target="_blank">HTML Tidy</a>: <i>installed</i> (version <i>' . tidy_get_release() . '</i>)<br />' . "\n";
        }
        else {
            echo '<a href="http://php.net/ref.tidy" target="_blank">HTML Tidy</a>: <i>not installed</i> (optional)<br />' . "\n";
        }

        echo '<br />' . "\n";
        echo '<a href="http://www.famfamfam.com/lab/icons/silk/" target="_blank">Silk Icons</a> by Mark James.' . "\n";
        echo '<br />' . "\n";

        if ( !defined( "ONPUBGUI_SQLITE_DB_FILE" ) ) {
            echo '<br />' . "\n";
            echo 'If you are using a public computer, <a href="index.php?onpub=Logout">Logout</a> when you are finished using Onpub.' . "\n";
        }

        echo '<br />' . "\n";
        echo '</div>' . "\n";

        $widget = new OnpubWidgetFooter();
        $widget->display();
    }

    public function validate()
    {

    }

    public function process()
    {

    }
}

?>
