<?php

/**
 * @author {@link mailto:corey@onpubco.com Corey HM Taylor}
 * @copyright Onpub (TM) Copyright (C) 2008, Onpubco
 * {@link http://onpubco.com/}
 * @license http://www.gnu.org/copyleft/gpl.html GNU General Public License
 * Version 2
 * @package onpubgui
 * @version 0.8.7
 */
class OnpubWidgetImages
{
    private $heading;
    private $imageID;
    private $images;
    private $website;

    function __construct( $heading, $imageID, $images, $website = null )
    {
        $this->heading = $heading;
        $this->imageID = $imageID;
        $this->images = $images;
        $this->website = $website;
    }

    function display()
    {
        $image = null;

        if ( sizeof( $this->images ) ) {
            echo '<tr>' . "\n";
            echo '<td><b>' . $this->heading . '</b><br />' . "\n";

            if ( $this->imageID ) {
                echo '<select name="imageID" size="1">' . "\n";

                echo '<option value="">None</option>';

                for ( $i = 0; $i < sizeof( $this->images ); $i++ ) {
                    if ( $this->images[$i]->ID == $this->imageID ) {
                        $image = $this->images[$i];
                        echo '<option value="' . $this->images[$i]->ID . '" selected="selected">' . strip_tags( $this->images[$i]->fileName ) . '</option>';
                    }
                    else {
                        echo '<option value="' . $this->images[$i]->ID . '">' . strip_tags( $this->images[$i]->fileName ) . '</option>';
                    }
                }

                echo '</select>' . "\n";

                if ( $this->website && $image ) {
                    if ( $this->website->imagesURL ) {
                        if ( @fopen( $this->website->imagesURL . rawurlencode( $image->fileName ), 'r' ) ) {
                            echo '<div style="padding-top: 5px;"><a href="index.php?onpub=EditImage&amp;ID=' . $image->ID . '"><img src="' . $this->website->imagesURL . $image->fileName . '" alt="Edit" title="Edit" border="0" /></a></div>' . "\n";
                        }
                        else {
                            echo ' <img src="gui/icons/picture_error.png" align="top" width="16" height="16" alt="' . $this->website->imagesURL . rawurlencode( $image->fileName ) . ' not found" title="' . $this->website->imagesURL . rawurlencode( $image->fileName ) . ' not found" /><br /><span class="tip">Tip:</span> make sure the Images URL of Website <a href="index.php?onpub=EditWebsite&amp;websiteID=' . $this->website->ID . '">' . $this->website->name . '</a> is setup correctly.' . "\n";
                        }
                    }
                }
            }
            else {
                echo '<select name="imageID" size="1">' . "\n";

                echo '<option value="">None</option>';

                for ( $i = 0; $i < sizeof( $this->images ); $i++ ) {
                    echo '<option value="' . $this->images[$i]->ID . '">' . strip_tags( $this->images[$i]->fileName ) . '</option>';
                }

                echo '</select>' . "\n";
            }

            echo '</td>' . "\n";
            echo '</tr>' . "\n";
        }
    }
}

?>
