<?php

/* Onpub (TM)
 * Copyright (C) 2008 Onpubco <http://onpubco.com/>
 * Author: Corey HM Taylor <corey@onpubco.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; version 2.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

// SQLite Database Configuartion
// Uncomment the following define to use an SQLite database file (feel free to
// change the name/path of the file).
// The sqlite database file and directory should be owned by the user the
// web server is running as.
// Leave the following define commented out to use a database that requires
// authentication (e.g. MySQL, more secure for public websites)
//define( "ONPUBGUI_SQLITE_DB_FILE", "/var/lib/onpub/onpub.sqlite" );

// Directory Configuration
// Icons, buttons and other Onpub GUI graphics are stored in this directory
define( "ONPUBGUI_IMAGE_DIRECTORY", "gui/images/" );

// UI Configuration
// Controls how many rows get displayed on each page in the Select UIs
define( "ONPUBGUI_PDO_ROW_LIMIT", 10 );
// Controls what time zone to use if date.timezone is not set in php.ini.
define( "ONPUBGUI_DEFAULT_TZ", "America/New_York" );

// Error codes for GUI exceptions
define( "ONPUBGUI_ERROR_MOVE_UPLOADED_FILE", 2 );
define( "ONPUBGUI_ERROR_CHMOD", 3 );
define( "ONPUBGUI_ERROR_IMAGE_TYPE", 4 );

// User Interface Classes
include( "classes/OnpubNewArticle.php" );
include( "classes/OnpubNewSection.php" );
include( "classes/OnpubNewWebsite.php" );

include( "classes/OnpubDeleteArticles.php" );

include( "classes/OnpubEditArticle.php" );
include( "classes/OnpubEditImage.php" );
include( "classes/OnpubEditSection.php" );
include( "classes/OnpubEditWebsite.php" );

include( "classes/OnpubMoveArticles.php" );

include( "classes/OnpubLogin.php" );
include( "classes/OnpubWelcome.php" );

include( "classes/OnpubEditArticles.php" );
//include( "classes/OnpubEditComments.php" );
include( "classes/OnpubEditImages.php" );
include( "classes/OnpubEditSections.php" );
include( "classes/OnpubEditWebsites.php" );

include( "classes/OnpubUploadImages.php" );

include( "classes/OnpubTidy.php" );

include( "classes/OnpubViewArticle.php" );

include( "classes/OnpubWidgetArticles.php" );
include( "classes/OnpubWidgetDateCreated.php" );
include( "classes/OnpubWidgetFooter.php" );
include( "classes/OnpubWidgetHeader.php" );
include( "classes/OnpubWidgetImages.php" );
include( "classes/OnpubWidgetPaginator.php" );
include( "classes/OnpubWidgetPDOException.php" );
include( "classes/OnpubWidgetSearch.php" );
include( "classes/OnpubWidgetSelectSection.php" );
include( "classes/OnpubWidgetSections.php" );
include( "classes/OnpubWidgetStats.php" );
include( "classes/OnpubWidgetSelectWebsite.php" );
include( "classes/OnpubWidgetWebsites.php" );

?>
