<?php

/* Onpub (TM)
 * Copyright (C) 2008 Onpubco <http://onpubco.com/>
 * Author: Corey HM Taylor <corey@onpubco.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; version 2.
 */

include '../api/onpubapi.php';
include 'php/functions.php';
include 'php/config.php';
include 'php/init.php';

en( '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"' );
en( '"http://www.w3.org/TR/html4/strict.dtd">' );
en( '<html>', 2 );
en( '<head>' );
en( '<meta http-equiv="Content-Type" content="text/html; ' .
    'charset=iso-8859-1" />' );

if ( $index == 'home' ) {
    en( '<title>' . $website->name . '</title>' );
}
elseif ( $index == 'section' ) {
    if ( $section ) {
        en( '<title>' . $website->name . ' - ' . $section->name . '</title>' );
    }
    else {
        en( '<title>' . $website->name . ' - Section ' . $_GET['sectionID'] .
            ' does not exist.</title>' );
    }
}
elseif ( $index == 'article' ) {
    if ( $article ) {
        en( '<title>' . $website->name . ' - ' . $article->title .
            '</title>' );
    }
    else {
        en( '<title>' . $website->name . ' - Article ' . $_GET['articleID'] .
            ' does not exist.</title>' );
    }
}
elseif ( $index == 'section-article' ) {
    if ( $section && $article ) {
        en( '<title>' . $website->name . ' - ' . $section->name . ' - ' .
            $article->title . '</title>' );
    }
    else {
        if ( $section ) {
            en( '<title>' . $website->name . ' - ' . $section->name .
                ' - Article ' . $_GET['articleID'] .
                ' does not exist.</title>' );
        }
        else {
            en( '<title>' . $website->name . ' - Section ' .
                $_GET['sectionID'] . ' does not exist.</title>' );
        }
    }
}

en( '<link rel="stylesheet" type="text/css" ' .
    'href="css/yui/reset-fonts-grids.css">' );
en( '<link rel="stylesheet" type="text/css" href="' . $cssFile . '">' );
en( '</head>', 2 );
en( '<body>' );
en( '<div id="doc2" class="yui-t1">', 2 );

en( '<div id="hd">' );
en( '<a href="index.php">' . $website->name . '</a>' );
en( '</div>', 2 );

en( '<div id="bd">', 2 );

en( '<div id="yui-main">' );
en( '<div id="main" class="yui-b">' );

if ( $index == 'home' ) {
    $homeArticle = $oa->get( $homeArticleID );

    if ( $homeArticle ) {
        en( $homeArticle->title );
        br( 2 );
        en( $homeArticle->content );
    }
    else {
        en( '<span class="error">Article ' . $homeArticleID . ' does not ' .
            'exist.</span>' );
    }
}
elseif ( $index == 'section' ) {
    if ( $section ) {
        $articles = $section->articles;

        foreach ( $articles as $a ) {
            en( '<a href="index.php?sectionID=' . $_GET['sectionID'] .
                '&amp;articleID='. $a->ID . '">' . $a->title . '</a>' );
            br();
        }
    }
    else {
        en( '<span class="error">Section ' . $_GET['sectionID'] .
            ' does not exist.</span>' );
    }
}
elseif ( $index == 'article' ) {
    if ( $article ) {
        en( $article->title );
        br( 2 );
        en( $article->content );
    }
    else {
        en( '<span class="error">Article ' . $_GET['articleID'] .
            ' does not exist.</span>' );
    }
}
elseif ( $index == 'section-article' ) {
    if ( $article ) {
        en( $article->title );
        br( 2 );
        en( $article->content );
    }
    else {
        en( '<span class="error">Article ' . $_GET['articleID'] .
            ' does not exist.</span>' );
    }
}

en( '</div>' );
en( '</div>', 2 );

en( '<div id="nav" class="yui-b">' );

$sections = $website->sections;

if ( sizeof( $sections ) ) {
    foreach ( $sections as $s ) {
        en( '<a href="index.php?sectionID=' . $s->ID . '">' . $s->name .
            '</a>' );
        br();
    }
}

en( '</div>', 2 );

en( '</div>', 2 );

en( '<div id="ft">' );

$dt = new DateTime();

en( '&copy; '. $dt->format( 'Y' ) . ' ' . $website->name );

en( '</div>', 2 );

en( '</div>' );
en( '</body>', 2 );
en( '</html>' );

?>
