<?php

try {
    $pdo = new PDO( 'mysql:host=' . $dbHost . ';dbname=' . $dbName, $dbUser,
                    $dbPass );
}
catch ( PDOException $e ) {
    en( '<span style="color: red;">' . $e->getMessage() . '</span>' );
    exit;
}

$ow = new OnpubWebsites( $pdo );
$oa = new OnpubArticles( $pdo );
$os = new OnpubSections( $pdo );

$qo = new OnpubQueryOptions();
$qo->includeSections = true;

try {
    $website = $ow->get( $websiteID, $qo );
}
catch ( PDOException $e ) {
    en( '<span style="color: red;">' . $e->getMessage() . '</span>' );
    exit;
}

if ( !$website ) {
    en( '<span style="color: red;">Website ' . $websiteID .
        ' does not exist.</span>' );
    exit;
}

$index = 'home';

if ( isset( $_GET['sectionID'] ) && !isset( $_GET['articleID'] ) ) {
    if ( !ctype_digit( $_GET['sectionID'] ) ) {
        en( '<span style="color: red;">sectionID must be an integer.</span>' );
        exit;
    }

    $qo = new OnpubQueryOptions();
    $qo->includeArticles = true;
    $qo->includeContent = false;

    try {
        $section = $os->get( $_GET['sectionID'], $qo );
    }
    catch ( PDOException $e ) {
        en( '<span style="color: red;">' . $e->getMessage() . '</span>' );
        exit;
    }

    $index = 'section';
}
elseif ( !isset( $_GET['sectionID'] ) && isset( $_GET['articleID'] ) ) {
    if ( !ctype_digit( $_GET['articleID'] ) ) {
        en( '<span style="color: red;">articleID must be an integer.</span>' );
        exit;
    }

    try {
        $article = $oa->get( $_GET['articleID'] );
    }
    catch ( PDOException $e ) {
        en( '<span style="color: red;">' . $e->getMessage() . '</span>' );
        exit;
    }

    $index = 'article';
}
elseif ( isset( $_GET['sectionID'] ) && isset( $_GET['articleID'] )  ) {
    if ( !ctype_digit( $_GET['sectionID'] ) ) {
        en( '<span style="color: red;">sectionID must be an integer.</span>' );
        exit;
    }

    if ( !ctype_digit( $_GET['articleID'] ) ) {
        en( '<span style="color: red;">articleID must be an integer.</span>' );
        exit;
    }

    try {
        $section = $os->get( $_GET['sectionID'] );
        $article = $oa->get( $_GET['articleID'] );
    }
    catch ( PDOException $e ) {
        en( '<span style="color: red;">' . $e->getMessage() . '</span>' );
        exit;
    }

    $index = 'section-article';
}

?>
